<?php
// File: $Id: index.php,v 1.13 2003/07/04 06:48:33 larsneo Exp $ $Name:  $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of this file: Francisco Burzi
// Purpose of this file: Directs to the start page as defined in config.php
// ----------------------------------------------------------------------

// include base api
include 'includes/pnAPI.php';

// start PN
pnInit();

// Get variables
list($module,
     $func,
     $op,
     $name,
     $file,
     $type,) = pnVarCleanFromInput('module',
                                  'func',
                                  'op',
                                  'name',
                                  'file',
                                  'type');

// Defaults for variables
if (isset($catid)) {
    pnVarCleanFromInput('catid');
}

// check requested module and set to start module if not present
if (empty($name)) {
    $name = pnConfigGetVar('startpage');
    // fixed for the new style of loading modules and set start page for them [class007]
    if (empty($module)) {
        $module = $name;
    }
}

// get module information
$modinfo = pnModGetInfo(pnModGetIDFromName($module));

if ($modinfo['type'] == 2)
{
    // New-new style of loading modules
    if (empty($type)) {
        $type = 'user';
    }
    if (empty($func)) {
        $func="main";
    }

    // it should be $module not $name [class007]
    if (pnModAvailable($module)) {
        if (pnModLoad($module, $type)) {
            // Run the function
            $return = pnModFunc($module, $type, $func);
        } else {
            $return = false;
        }
    } else {
        $return = false;
    }

	/* do we really need this here [larsneo]
    if (function_exists('session_write_close')) {
        session_write_close();
    }
    */

    // Sort out return of function.  Can be
    // true - finished
    // false - display error msg
    // text - return information
    if ((empty($return)) || ($return == false)) {
        // Failed to load the module
        $output = new pnHTML();
        $output->StartPage();
        $output->Text('Failed to load module ' . $module .' ( At function: "'.$func.'" )');
        $output->EndPage();
        $output->PrintPage();
        exit;
    } elseif (strlen($return) > 1) {
        // Text
        $output = new pnHTML();
        $output->StartPage();
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text($return);
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->EndPage();
        $output->PrintPage();
/*
// double check - markwest
// this seems to interfere with modules that provide printable outpages
// within api compliant module structure (e.g. htmlpages)
    } else {
        // blank module. debug purpose only
        $output = new pnHTML();
        $output->StartPage();
        $output->EndPage();
        $output->PrintPage();
// So let us make it work first. I don't want to see a completely blank page for blank module as startpage [class007]
*/
    } else {
    	/*
    	// this doesn't work with /includes/blocks/finclude.php 
    	// (view of permission instances/components)
        $output = new pnHTML();
        $output->StartPage();
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text('Function <I>'.$func.'</I> in module <I>' . $module .'</I> return TRUE!');
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->EndPage();
        $output->PrintPage();
        */
    }
    exit;
} else {
    // Old-old style of loading modules
    if (empty($op)) {
        $op = "modload";
    }
    if (empty($file)) {
        $file="index";
    }
    
    include 'includes/legacy.php';
    switch ($op) {
        case 'modload':

            define("LOADED_AS_MODULE","1");
            // added for the module/system seperation [class007]
            if (file_exists('modules/' . pnVarPrepForOS($name) . '/' . pnVarPrepForOS($file) . '.php')) {
                include 'modules/' . pnVarPrepForOS($name) . '/'  . pnVarPrepForOS($file) . '.php';
            } else {
                // Failed to load the module
                $output = new pnHTML();
                $output->StartPage();
                $output->Text('Failed to load module ' . $module);
                $output->EndPage();
                $output->PrintPage();
                exit;
            }
            break;
        default:
            // Failed to load the module
            $output = new pnHTML();
            $output->StartPage();
            $output->Text('Sorry, you cannot access this file directly...');
            $output->EndPage();
            $output->PrintPage();
            break;
    }
    
    /* do we really need this here [larsneo]
    if (function_exists('session_write_close')) {
        session_write_close();
    } else {
        // Hack for old versions of PHP with bad session save
        $sessvars = '';
        foreach ($GLOBALS as $k => $v) {
            if ((preg_match('/^PNSV/', $k)) &&
                (isset($v))) {
                $sessvars .= "$k|" . serialize($v);
            }
        }
        pnSessionWrite(session_id(), $sessvars);
    }
    exit;
    */
}
?>